; R[h͂rihr sR[h͂bqke
; $Id: HuffmanCode_asm.asm 154 2008-05-05 08:02:22Z umezawa $

; Ut Video Codec Suite
; Copyright (C) 2008  UMEZAWA Takeshi
; 
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
; 
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
; 
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
; 
; 
; Ut Video Codec Suite
; Copyright (C) 2008  ~V Ўu
; 
; ̃vO̓t[\tgEFAłBȂ͂At[\t
; gEFAcɂĔsꂽ GNU ʌOp_(o[W
; 2A]ɂĂ͂ȍ~̃o[Ŵǂꂩ)̒߂
; ̉ōĔЕz܂͉ς邱Ƃł܂B
; 
; ̃vO͗Lpł邱ƂĔЕz܂A*S̖
; * łBƉ\̕ۏ؂̖ړIւ̓ḰAOɎꂽ
; ̂܂ߑS݂܂BڂGNU ʌOp_񏑂
; B
; 
; Ȃ͂̃vOƋɁAGNU ʌOp_񏑂̕
; ꕔ󂯎͂łB󂯎ĂȂ΁At[\tgEF
; Ac܂ŐĂ( the Free Software Foundation,
; Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA)B

.686
.no87
.xmm

.model	flat

extrn	_memset:PROC


_TEXT_ASM	SEGMENT	page public flat 'CODE'

; void i686_HuffmanEncode_align1(BYTE *pDstBegin, const BYTE *pSrcBegin, const BYTE *pSrcEnd, const HUFFMAN_ENCODE_TABLE *pEncodeTable)
public	_i686_HuffmanEncode_align1
_i686_HuffmanEncode_align1	proc

	push		ebx
	push		esi
	push		edi
	push		ebp

	mov			esi, dword ptr [esp + 16 + 4 +  4]	; pSrcBegin
	mov			edi, dword ptr [esp + 16 + 4 +  0]	; pDstBegin
	mov			edx, dword ptr [esp + 16 + 4 +  8]	; pSrcEnd
	mov			ebp, dword ptr [esp + 16 + 4 + 12]	; pEncodeTable
	cmp			dword ptr [ebp], 0
	je			label3
	mov			cl, -32
	xor			eax, eax

	align		64
label1:
	cmp			esi, edx
	jnb			label4
	movzx		edx, byte ptr [esi]
	inc			esi
	mov			edx, dword ptr [ebp+edx*4]
	mov			ch, dl
	and			edx, 0ffffff00h
	mov			ebx, edx
	shr			edx, cl
	or			eax, edx
	mov			edx, dword ptr [esp + 16 + 4 +  8]	; pSrcEnd
	add			cl, ch
	jnc			label1
	mov			dword ptr [edi], eax
	add			edi, 4
	sub			cl, ch
	xor			eax, eax
	shrd		eax, ebx, cl
	add			cl, ch
	sub			cl, 32
	jmp			label1

label4:
	test		cl, 1fh
	jz			label3
	mov			dword ptr [edi], eax
	add			edi, 4
label3:
	mov			eax, edi			; Ԃl eax ɁB
	sub			eax, dword ptr [esp + 16 + 4 +  0]	; pDstBegin

	pop			ebp
	pop			edi
	pop			esi
	pop			ebx
	ret

_i686_HuffmanEncode_align1	endp


; void i686_HuffmanEncode_align1(BYTE *pDstBegin, BYTE *pDstcEnd, const BYTE *pSrcBegin, const HUFFMAN_DECODE_TABLE *pDecodeTable)
public	_i686_HuffmanDecode_align1
_i686_HuffmanDecode_align1	proc

	push		ebx
	push		esi
	push		edi
	push		ebp

	mov			esi, dword ptr [esp + 16 + 4 +  8]	; pSrcBegin
	mov			edi, dword ptr [esp + 16 + 4 +  0]	; pDstBegin
	mov			ebx, dword ptr [esp + 16 + 4 + 12]	; pDecodeTable
	mov			edx, dword ptr [esi+4]
	mov			ch, -32

	cmp			byte ptr [ebx + 32+4*32+4*1024], 0	; pDecodeTable->nCodeLength[0]
	jne			label1

	; msmset(pDstBegin, pDecodeTable->dwSymbol[0], pDstEnd-pDstBegin);
	mov			eax, dword ptr [esp + 16 + 4 +  4]	; pDstEnd
	sub			eax, edi
	push		eax
	mov			eax, dword ptr [ebx + 32+4*32]		; pDecodeTable->dwSymbol[0]
	push		eax
	push		edi
	call		_memset
	add			esp, 4*3

	jmp			label2

	align		64
label1:
	cmp			edi, dword ptr [esp + 16 + 4 +  4]	; pDstEnd
	jae			label2
	mov			eax, dword ptr [esi]
	mov			cl, ch
	shld		eax, edx, cl
	or			eax, 1
	bsr			ebp, eax
	mov			cl, byte ptr [ebx + ebp]					; pDecodeTable->nCodeShift[ebp]
	shr			eax, cl
	mov			ebp, dword ptr [ebx + 32 + ebp*4]			; pDecodeTable->dwSymbolBase[ebp]
	add			ebp, eax
	mov			eax, dword ptr [ebx + 32+4*32 +ebp*4]		; pDecodeTable->dwSymbol[ebp]
	mov			byte ptr [edi], al
	inc			edi
	add			ch, byte ptr [ebx + 32+4*32+4*1024 + ebp]	; pDecodeTable->nCodeLength[ebp]
	jnc			label1
	sub			ch, 32
	add			esi, 4
	mov			edx, dword ptr [esi+4]
	jmp			label1

label2:
	pop			ebp
	pop			edi
	pop			esi
	pop			ebx
	ret

_i686_HuffmanDecode_align1	endp


end
